package pinball;

import pinball.*;
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.buffer.*;
import pinball.menuevent.*;

import pinball.player.standard.*;

import java.awt.*;
import java.io.*;
import java.util.*;

/**
 * Sets up the system in batch mode.
 */
public class BatchMode {
	/** The batch file. */
	private DataInputStream batch;
	
	/**
	 * Do the batch mode.
	 *
	 * @param batch Where to read the batch file from.
	 */
	public BatchMode (DataInputStream batch) {
		this.batch=batch;
		process();
	}

	/**
	 * Process the batch file.
	 */	
	public void process() { 
		String data;
		StringTokenizer tokens;
		String command;
		
		/* Find the commands in the batch file and process them. */
		try{		
			while((data=batch.readLine())!=null) {
				command=null; 			
				tokens = new StringTokenizer(data);
						
				if(tokens.countTokens()>1)
					command=tokens.nextToken();
				else command=data;
				if(command!=null) {
					if(command.equals("post"))
						GameOptions.post(new Boolean(tokens.nextToken()).booleanValue());
					else if(command.equals("analyze"))
						GameOptions.analyze(new Boolean(tokens.nextToken()).booleanValue());
					else if(command.equals("strategy"))
						GameOptions.strategy(new Boolean(tokens.nextToken()).booleanValue());
					else if(command.equals("pixel"))
						GameOptions.pixelRate(new Integer(tokens.nextToken()).intValue());
					else if(command.equals("buffers"))
						GameOptions.bufferSize(new Integer(tokens.nextToken()).intValue());
					else if(command.equals("flipperChecks"))
						GameOptions.findFlippers(new Integer(tokens.nextToken()).intValue());
					else if(command.equals("flipperResetTime"))
						GameOptions.resetTime(new Integer(tokens.nextToken()).intValue());
					else if(command.equals("ballsToPlay"))
						GameOptions.ballsToPlay(new Integer(tokens.nextToken()).intValue());
					else if(command.equals("timeToPlay"))
						GameOptions.timeToPlay(new Integer(tokens.nextToken()).intValue()*1000);
					else if(command.equals("logFile"))
						GameOptions.logFileName(tokens.nextToken());
					else System.err.println("Invalid Batch Command: "+data);
				}
			}
		}
		catch (Exception e){System.err.println(e);}
	}
}
