package pinball;

import pinball.*;
import pinball.buffer.*;

import java.io.*;
import java.util.*;
import java.net.*;
import java.text.*;
import java.applet.*;

/**
 * Used to access the video log file.
 */
public class VideoLog{
	/** Output file. */
	private FileOutputStream out;
	
	/** Output file. */
        private ObjectOutputStream logout;
	
	/** Input file. */
	private InputStream in;
	
	/** Input file. */
        private ObjectInputStream login;		

	/* Log filename parts. */

	/** Time & Date of the log file. */
	private String logTimeDate;
	
	/** Ball number for log file. */
	private int ballNumber=1;
	
	/** The remainder part of the log file. */
   	private String remainder;

	/** The applet that's displaying. */
	private Applet applet;
	
	/** Create a log file. */
	public VideoLog(){}
		
	/** 
	 * Create a log file with the specified applet. 
	 *
 	 * @param applet the applet that is displaying.
	 */
	public VideoLog(Applet applet) {
		this.applet=applet;
	}
		
	/** 
	 * Create a log file with the specified first log file name. 
	 *
	 * @param start the first log file.
	 */
	public VideoLog(String start) {
		/* Separate the file name into it's parts. */
		StringTokenizer	st=new StringTokenizer(start,"_");		
		logTimeDate=st.nextToken();
		ballNumber=new Integer(st.nextToken()).intValue();
		ballNumber--;
		remainder=st.nextToken(" ");
	}
	
	/** 
	 * Get the next log file to read from. 
	 *
	 * @param log the next log file.
	 */
	public ObjectInputStream getReadNext(String log) throws IOException {		
		//in = new java.util.zip.ZipInputStream(new URL(applet.getDocumentBase(),log).openStream());
		in=new URL(applet.getDocumentBase(),log).openStream();
		login = new ObjectInputStream(in);

		return login;
	}


	/** 
	 * Get the next log file to read from. 
	 *
	 * @param log the next log file.
	 */
	public ObjectInputStream getReadNext() throws IOException {
		String file=getNext();
		
		System.err.println("Opening video file "+file);
		
		in = new FileInputStream(file);
		login = new ObjectInputStream(in);

		return login;
	}
	
	/** Set the ball number. */
	private String ballNumber() {
		if(ballNumber<10)
			return new String("00"+ballNumber);
		else if(ballNumber<100)
			return new String("0"+ballNumber);
		else return new String(""+ballNumber);
	}
	
	/**
	 * Get the name log file name 
	 */
	private String getNext() {
		ballNumber++;
		return logTimeDate+"_"+ballNumber()+remainder;		
	}


	/**
	 * Get the next log file to write to.
	 *
	 * @param log the next log file.	 
	 */
	public ObjectOutputStream getWriteNext(String log) throws IOException {

		out = new FileOutputStream(log);
		logout = new ObjectOutputStream(out);

		return logout;
	}

}
