package pinball.applet.human;

import java.applet.Applet;
import java.awt.*;
import pinball.*;
import pinball.player.*;
import pinball.server.*;
import pinball.player.network.*;
import pinball.server.*;

public class Connection extends Thread{
	private Label status;
	private MyClient client;
	private HumanPlayerApplet applet;
	private NetworkDataSocket socket;
	
	private Thread humanPlayer;
	private boolean running=false;
	
	public Connection(Label status, HumanPlayerApplet applet) {
		this.status=status;
		this.applet=applet;
		start();
	}
	
	public void run() {
		if(connect() && waitTurn()) {
			Strategy human = new HumanStrategy(applet,client);
		
			humanPlayer=new Thread(human);
		
			humanPlayer.start();
			running=true;
			timeCheck();
		}
	}
	
	private boolean connect() {
		GameOptions.networkHost(applet.getCodeBase().getHost());
		GameOptions.clientMode();
 
		/* Connect to the server. */
		client=new MyClient();
		if(client.dataSocket()!=null) {
			socket=new NetworkDataSocket(client.dataSocket());
		}
		

		String data=client.receive();

		if(data!=null && data.compareTo(TicketServer.CONNECTED)==0) {
			status.setText("Connected");
			System.err.println("Got connected.");
			return true;
		}
		else if(data!=null && data.compareTo(TicketServer.REJECTED)==0) {
			status.setText("Server Is Full");
			return false;
		}
		else {
			status.setText("No Response From Server");
			System.err.println("Server's not online. Try again another time.");
			return false;
		}
	}
	
	private boolean waitTurn() {
		String data;
		System.err.println("Waiting my turn");

		/* Get queue position, until the "THERE" command appears. */
		data=client.receive();
		while(data==null || data.compareTo(TicketServer.THERE)!=0) {
			if(data!=null)
				status.setText(data);
			data=client.receive();
			Thread.yield();
		}
		
		System.err.println("I'm in");
		client.transmit(TicketServer.HERE);

		/* Try to get port number. */
		while((data=client.receive())==null) {
			Thread.yield();			
		}
				
		//System.err.println("Got port at "+data);
		
		/* Got port number. */
		if(data!=null) {
			int port=new Integer(data).intValue();
			GameOptions.networkPort(port);
			client=null;
			client=new MyClient();
			return true;
		}
		else return false;
	}
	
	public void timeCheck() {
		String data="";
		
		try{
			while(data!=null && running) {
				data=socket.receive();

				int time=new Integer(data).intValue();
		
				int min=time/60000;
		
				time-=min*60000;
				int sec=time/1000;
	
				if(sec>=10)
					status.setText("Time Remaining "+min+":"+sec);
				else if(sec<10)
					status.setText("Time Remaining "+min+":0"+sec);
				Thread.yield();
			}
		}
		catch(Exception e){}
		
		status.setText("Disconnected");
	}
	
	public void finish() {
		running=false;
		if(humanPlayer!=null)
			humanPlayer.stop();
	}

		
}
