package pinball.applet.human;

import pinball.server.*;
import java.io.*;
import java.util.*;

public class Exec extends Thread{
	private NetworkDataSocket socket; 
	private Process process;
	private String command;
	private long runningTime = 30000;
	private boolean processRunning;	

	public Exec(String command, NetworkDataSocket socket) {
		this.command=command;
		this.socket=socket;
		start();
	}
	
	public void run() {
		System.err.println("Going to start game");
		try{process=Runtime.getRuntime().exec(command);}
		catch(Exception e){System.err.println(e);System.exit(1);}
		
		System.err.println("CHECKING FOR PORT");
		
		// Create an input stream so we can catch the process' output stream
		 BufferedReader output = new BufferedReader
		 ( new InputStreamReader( process.getInputStream() ) );

		String port="NONE";
		try{
			String data;
			StringTokenizer tokens;
			String command;
		
			while((data=output.readLine())!=null) {
				System.err.println("DATA: "+data);
				command=null; 			
				tokens = new StringTokenizer(data);
		
				if(tokens.countTokens()>1)
					command=tokens.nextToken();
				else command=data;

		 		if(command.equals("PORT") && tokens.countTokens()==1) {				
					port=tokens.nextToken();
					break;
				}
			}
		
			socket.transmit(port);

			System.err.println("Port is at: "+port);
			//process.destroy();
			System.err.println("DONE");
		}
		catch(Exception e){System.err.println(e);System.exit(1);}
		System.err.println("RUNNING");
		

		processRunning=true;
		long timeElapsed=0;
		long startTime=System.currentTimeMillis();
		while(processRunning && timeElapsed<=runningTime) {
			timeElapsed=System.currentTimeMillis()-startTime;
			System.err.println("RUNNING TIME: "+timeElapsed);

			try{
				process.exitValue();
				/* If reached this instuction,
				   the process has finished.
				   Otherwise an exception would
				   have happened and it would have
				   skipped this instruction.
				*/
				processRunning=false;
			}
			catch(IllegalThreadStateException e) {}
			try{Thread.sleep(1000);}
			catch(Exception e) {System.err.println(e);System.exit(1);}
		}
		
		socket.close();
		

	}
}
