package pinball.applet.human;

import pinball.*;
import pinball.player.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;

/** Allows the human to play pinball by pressing keys on the keyboard. */

public class FlipperCommands implements KeyListener {
	
	/** The keys that control the flippers. */
	private final char leftKey='z', rightKey='/';
	
	/** Are the flippers up. */
	private boolean leftUp=false, rightUp=false;
		
	/** Pressed a flipper. */
	public void keyPressed(KeyEvent key) {
		//System.err.println("KEY");
		if(key.getKeyChar()==leftKey)
			leftUp=true;
		if(key.getKeyChar()==rightKey)			
			rightUp=true;					
	}
	
	/** Relased a flipper. */
	public void keyReleased(KeyEvent key) {		
		if(key.getKeyChar()==leftKey)
			leftUp=false;
		if(key.getKeyChar()==rightKey)			
			rightUp=false;
	}
		
	/** Generic Keyboard Events not used. */
	public void keyTyped(KeyEvent key) {
	}
	
	/** Is the left flipper pressed. */
	public boolean left() {
		return leftUp;
	}
	
	/** Is the right flipper pressed. */
	public boolean right() {
		return rightUp;
	}
}
