package pinball.applet.human;

import java.applet.Applet;
import java.awt.*;
import java.io.*;
import java.util.*;
import pinball.player.*;
import pinball.server.*;
import pinball.player.network.*;

public class Ticket {
	private NetworkDataSocket socket; 
	private TicketServer ticketServer;
	private int id;
	private Vector tickets;
	private Process process;
	private String command="java pinball.player.internet.InternetPlayer -B/tmp/internetBatch -F/tmp/internetFlip -S";
	private long runningTime = 180000;
	private boolean processRunning;	

	
	public Ticket(int id, Vector tickets) {
		this.id=id;
		this.tickets=tickets;
	}
	
	public int id() {
		return id;
	}
	
	public void waiting(NetworkDataSocket socket) {
		this.socket=socket;
	}
	
	public void message(String message) {
		socket.transmit(message);
	}
	
	public void play() {
		message("Loading game, please wait...");	
		socket.transmit(TicketServer.THERE);
		String data=socket.receive();
		
		if(data==null || data.compareTo(TicketServer.HERE)!=0) {
			System.err.println("Ticket Expired");
			socket.close();
			return;		
		}	
	
		try{process=Runtime.getRuntime().exec(command);}
		catch(Exception e){System.err.println(e);System.exit(1);}
		
		System.err.println("CHECKING FOR PORT");
		
		// Create an input stream so we can catch the process' output stream
		 BufferedReader output = new BufferedReader
		 ( new InputStreamReader( process.getInputStream() ) );

		String port="NONE";
		try{
			StringTokenizer tokens;
			String command;
		
			while((data=output.readLine())!=null) {
				System.err.println("DATA: "+data);
				command=null; 			
				tokens = new StringTokenizer(data);
		
				if(tokens.countTokens()>1)
					command=tokens.nextToken();
				else command=data;

		 		if(command.equals("PORT") && tokens.countTokens()==1) {				
					port=tokens.nextToken();
					break;
				}
				Thread.yield();
			}
		
			socket.transmit(port);

			System.err.println("Port is at: "+port);
			//process.destroy();
			System.err.println("DONE");
		}
		catch(Exception e){System.err.println(e);System.exit(1);}
		System.err.println("RUNNING");
		
		/* For the the connection to be established. */
		try{
			while((data=output.readLine())!=null) {
			 	if(data.equals("CONNECTIONESTABLISHED"))
					break;
				Thread.yield();
			}
		}
		catch(Exception e){System.err.println(e);System.exit(1);}
			

		processRunning=true;
		long timeElapsed=0;
		long startTime=System.currentTimeMillis();
		while(processRunning && timeElapsed<=runningTime) {
			timeElapsed=System.currentTimeMillis()-startTime;
			//System.err.println("RUNNING TIME: "+timeElapsed);
			socket.transmit(""+(runningTime-timeElapsed));
			try{
				process.exitValue();
				/* If reached this instuction,
				   the process has finished.
				   Otherwise an exception would
				   have happened and it would have
				   skipped this instruction.
				*/
				processRunning=false;
			}
			catch(IllegalThreadStateException e) {}
			try{Thread.yield();Thread.sleep(1000);}
			catch(Exception e) {System.err.println(e);System.exit(1);}
		}
		if(processRunning)
			process.destroy();
		socket.close();
		System.err.println("Running time was "+timeElapsed+" ms");
	}

}
