package pinball.applet.human;

import java.applet.Applet;
import java.awt.*;
import java.util.*;
import pinball.player.*;
import pinball.server.*;
import pinball.player.network.*;

public class TicketQueue {
	private Vector tickets;
	private Vector waiting=new Vector();
	private TicketTaker taker;
	
	public TicketQueue(Vector tickets) {
		this.tickets=tickets;
		taker=new TicketTaker(this);
	}
	
	public synchronized void add(Ticket ticket) {
		waiting.addElement(ticket);
		taker.ticketAvailable();
	}
	
	public synchronized int size() {
		return waiting.size();
	}
	
	public synchronized Ticket next() {
		Ticket t=(Ticket)waiting.elementAt(0);
		waiting.removeElementAt(0);
		return t;
	}		
	
	public synchronized void returnTicket(Ticket ticket) {
		tickets.addElement(ticket);
	}
	
	public void notifyWaiting() {
		for(int i=0;i<waiting.size();i++) {
			Ticket t=(Ticket)waiting.elementAt(i);
			/* Transmit size of queue. */
			if(i==1)
				t.message("There is 1 person waiting.");
			else if(i==0)
				t.message("You are next to play.");
			else t.message("There are "+i+" people waiting.");
		}
	}

}
