package pinball.applet.human;

import java.applet.Applet;
import java.awt.*;
import java.util.*;
import java.net.*;
import pinball.*;
import pinball.player.*;
import pinball.server.*;
import pinball.player.network.*;

public class TicketServer extends Thread{
	public static int MAXCLIENTS=5;

	public static String CONNECTED="CONNECTED";
	public static String REJECTED="REJECTED";
	public static String THERE="THERE";
	public static String HERE="HERE";
	
	private MyServer server;
	
	private ServerSocket serverSocket;
	private Process process;
	
	private Vector tickets=new Vector();
	private TicketQueue ticketQueue=new TicketQueue(tickets);
	private int nextClient;

	
	public static void main(String args[]) {
		TicketServer s=new TicketServer();
		s.start();
	}		
	
	public TicketServer() {
		for(int i=0;i<MAXCLIENTS;i++)
			tickets.addElement(new Ticket(i,tickets));
	}
	
	public void run() {
		server=new MyServer(GameOptions.networkPort(),30000,false);
		serverSocket=server.serverSocket();
		
		System.err.println("TicketServer is online...");
		while(true) {
			newClient();
			Thread.yield();
		}
	}
	
	/** See if a ticket is available. */
	public void newClient() {
		NetworkDataSocket socket=null;	

		System.err.println("Waiting for a client");
		try{
			socket = new NetworkDataSocket(serverSocket,30000);
		}
		catch (Exception e) {
	                System.err.println("Accept failed: "+e);
		}
		/* If there is a ticket take off the ticket. */
		if(tickets.size()!=0) {
			System.err.println("Ticket taken");
			
			/* Remove ticket from the list. */
			Ticket ticket=(Ticket)tickets.elementAt(0);
			tickets.removeElementAt(0);
			ticket.waiting(socket);
			socket.transmit(CONNECTED);
			
			/* Add ticket to the queue. */ 
			ticketQueue.add(ticket);
			
			/* Let the waiting tickets know their position. */
			ticketQueue.notifyWaiting();
		}

		/* No tickets left, close the socket. */
		else {
			System.err.println("Out of tickets");
			socket.transmit(REJECTED);
			socket.close();
		}
		
	}
}
