package pinball.applet.human;

import java.applet.Applet;
import java.awt.*;
import java.util.*;
import pinball.player.*;
import pinball.server.*;
import pinball.player.network.*;


public class TicketTaker extends Thread{

	private TicketQueue queue;
	private Ticket ticket;
	
	public TicketTaker(TicketQueue ticketQueue) {
		this.queue=ticketQueue;
		start();
	}
	
	/**
	 * Halt the the queue is not empty. 
	 */	
	public synchronized void halt() {
		while(queue.size()==0) {
			try {
				System.err.println("Waiting for a ticket. Ticket Queue: "+queue.size());
	                        wait();
			} 
			catch (InterruptedException e) {System.err.println(e);}
		}
	}	

	/**
	 * Notify the thread that a ticket is available. 
	 */
	public synchronized void ticketAvailable() {
		System.err.println("Wake me up");
		notifyAll();
	}
	
	public void run() {
		while(true) {
			halt();
			
			System.err.println("Working on ticket");
			ticket=queue.next();
			queue.notifyWaiting();
			ticket.play();
			System.err.println("Ticket Done");
			queue.returnTicket(ticket);
			Thread.yield();
		}
	}
	
}
