package pinball.buffer.ibuff;

import pinball.*;
import pinball.buffer.*;
import pinball.io.*;
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;

import java.io.*;
import java.util.*;

/** 
 * The information buffer's information.
 * This contains data about the frame from the camera.
 * It is passed around to each of the threads. Each thread makes whatever
 * analysis it needs to do on the information so that the system can play
 * pinball. 
 * @see pinball.buffer.Buffer
 */
public class IBuffInfo extends BufferInfo{
	protected InputDevices devices;
	
	/** 
	 *Build the buffer information. 
	 *
	 * @param id id number for buffer.
	 */
	public IBuffInfo(int id, InputDevices devices) {	
		super(id);
		this.devices=devices;
	}

	public InputDevices devices() {
		return devices;
	}
}
