package pinball.io;

import java.io.*;
import java.util.*;
import pinball.*;

/** 
 * The data IO for the pinball system.
 *
 */
public class DataIO extends ADR2200{
	/** The test port. */
	private static final String testPort = "/dev/cuaa0";

	/**
	 * Create the IO device at the port specified. 
	 *
	 * @param port serial port location.
	 */
	public DataIO (String port) {
		super(port);
	}

	/** Using the default port. */
	public DataIO () {
		super(testPort);
	}
	
	/** The default port for a specific board.
	 *
	 * @param board the board to control.
	 */
	public DataIO (int board) {
		super(testPort,board);
	}

	/** The default port for a specific board. 
	 *
	 * @param port serial port location.
	 * @param board the board to control.
	 */
	public DataIO (String port, int board) {
		super(port,board);
	}

	public static void main(String args[]){
		new DataIO();
		System.err.println("Relays reset");
		System.exit(0);
	}
}
