package pinball.io;

import java.io.*;
import java.util.*;
import pinball.*;

/**
 * Data to be written to the port. 
 */
public class SerialData {
	/** Data to be written. */
	private String data;
	
	/** Delay needed. */
	private boolean delay;
	
	/**
	 * Set the data & the weither or not a delay is needed. 
	 *
	 * @param data Data to be written.
	 * @param delay If a delay is needed.
	 */
	public SerialData(String data,boolean delay){
		this.data=data;
		this.delay=delay;
	}
	
	/**
	 * Set the data with no delay. 
	 *
	 * @param data Data to be written.
	 */
	public SerialData(String data){
		this.data=data;
		this.delay=false;
	}
	
	/**
	 * Get the data.
	 *
	 * @return the data to be written. 
	 */
	public String getData() {
		return data;
	}
	
	/**
	 * See if a delay is needed. 
	 *
	 * @return delay status.
	 */
	public boolean delayStatus() {
		return delay;
	}
}
