package pinball.log;

import java.io.*;
import java.util.*;
import java.text.*;

/**
 * The statistics for a ball. Finds the time in play, and number of hits.
 **/

public class BallStat {
	/** Ball number. */
	private int number;
	
	/** Time in play. */
	private long time;
	
	/** Number of hits. */
	private int hits;
	
	/**
	 * Creats a statistics object for the ball.
	 *
	 * @param number ball number
	 * @param time time in play
	 * @param hits number of hits for the ball.
	 */
	public BallStat(int number, long time, int hits) {
		this.number=number;
		this.time=time;
		this.hits=hits;
	}

	/**
	 * Get the ball's number.
	 *
	 * @return ball number.
	 */
	public int number(){
		return number;
	}
	
	/**
	 * Get the time in ball.
	 *
	 * @return time in play.
	 */
  	public long time() {
		return time;
	}
	
	/**
	 * Get the number of hits.
	 *
	 * @return amount of hits.
	 */	
	public int hits() {
		return hits;
	}
}
