package pinball.log;


import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;

/** Make a frame set for the statistics. */
public class FrameSet {
	/** The log files that have been processed. */
	private Vector logFiles;
	
	/** Root directory. */
	private String root;

	/** File that will get the data. */
	private PrintWriter output;
	
	/** The target frame */
	private String target="contents";

	/** The frame file */
	private String frameSetFile="index.html";
	
	/** The contents file */
	private String contents="contents.html";

	/** The stats file */
	private String stats="stats.html";
	
	/** Applet's location. */
	private String codebase="/";
	
	private int xsize=75, ysize=60;
	
	/**
	 * Generate the frame set for the statistics log files.
	 *
	 * @param logFiles the listing of the log files used.
	 * @param root the root location of the log files.
	 */
	public FrameSet(Vector logFiles, String root) {
		this.root=root+"/";
		System.err.println("ROOT:"+this.root);
		this.logFiles=logFiles;
		process();
	}

	/**
	 * Make the html files. 
	 */
	private void process() {
		try{
		output= new PrintWriter(new DataOutputStream(new FileOutputStream(root+frameSetFile)));
		}		
		catch(IOException e){System.err.println(e);}
		
		output.println("<HTML>\n<HEAD>");
 		output.println("<TITLE>Pinball Logs</TITLE>");
		output.println("</HEAD>");
		output.println("<FRAMESET COLS=\"200,*\">");
		output.println("<FRAME SRC=\""+contents+"\">");
    		output.println("<FRAME SRC=\""+stats+"\" NAME=\""+target+"\">");
		output.println("</FRAMESET>\n</FRAMESET>");
		output.println("</BODY></HTML>");

		output.close();
		
		try{
		output= new PrintWriter(new DataOutputStream(new FileOutputStream(root+contents)));
		}		
		catch(IOException e){System.err.println(e);}		
		
		output.println("<HTML>\n<HEAD>\n</HEAD>");
		
		output.println("<A href=\""+stats+"\" target=\""+target+"\">Statistics</a><DT>");
		output.println("<HR>Log files:<P>");
		
		String name;
		/* List the log files used. */
		for(int i=0;i<logFiles.size();i++) {
			name=(String)logFiles.elementAt(i);
			output.println("<A href=\""+name+"\" target=\""+target+"\">Ball "+(i+1)+" Log File</a><DT>");
			videoFile(name,root+"video"+(i+1)+".html");
			output.println("<A href=\""+"video"+(i+1)+".html"+"\" target=\""+target+"\">Ball "+(i+1)+" Video Clip</a><DT>");
		}
		output.println("</BODY></HTML>"); 
		output.close();

	}

	/**
	 * Make	code for the applet that displays the video file. 
	 * 
	 * @param file the file name of the video file.
	 * @param html the file for the applet to be displayed in.
	 */
	public void videoFile(String file, String html) {
		/** File that will get the data. */
		PrintWriter video=null;
	
		try{
		video= new PrintWriter(new DataOutputStream(new FileOutputStream(html)));
		}		
		catch(IOException e){System.err.println(e);}		

		video.println("<applet code=\"pinball.log.MoviePlayer\" ");
		video.println("codebase=\""+codebase+"\" width=500 height=300>");
		video.print("<PARAM name=logfile value=\"");
		video.println(file+"\">");
		video.println("<PARAM name=single value=\"true\">");		
		video.println("<PARAM name=xsize value=\""+xsize+"\">");
		video.println("<PARAM name=ysize value=\""+ysize+"\">");				
		video.print("</applet>"+"\n");
		
		video.close();
	}

}

