package pinball.log;

import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*;
import java.applet.*;

/** 
 * Opens a log file for reading or writing. 
 */
public class LogFile {
	/** File name of log file. */
	private String filename;

	/** Input file. */
        private BufferedReader reader=null;
		
	/** Output file. */
        private DataOutputStream writer=null;
	
	/**
	 * Opens a log file for reading or writting.
	 *
	 * @param name file name of the log file.
	 * @param how how the file is to be opened. w for write, r for read.
	 */
	public LogFile(String name, char how) throws IOException{
		filename=name;
		
		if(how=='w')
			writing();
		else if(how=='r')
			reading();
		else {
			System.err.println("File operation "+how+"  invalid");
			System.exit(1);
		}
	}
	
	/**
	 * Get the file from applets.
	 *
	 * @param name the filename.
	 * @param applet the applet that has file.
	 */	 
	public LogFile(String name, Applet applet) {
		try {
			System.err.println("FROM:"+applet.getDocumentBase());
			URL url = new URL(applet.getDocumentBase(), name);
			System.err.println(url);
			reader= new BufferedReader(new InputStreamReader(url.openStream()));
		}
		catch (Exception e) {System.err.println(e);}
	}
	
	/** Set the log file for reading. */
	private void reading() throws IOException{
		reader = new BufferedReader(new FileReader(filename));
	}

	/** Set the log file for writing. */
	private void writing() throws IOException {
		writer = new DataOutputStream(new FileOutputStream(filename));
	}


	/**
	 * Get the reading part of the file, if opened for reading. 
	 *
	 * @return The reading part of the file.
	 */
	public BufferedReader getReader(){
		return reader;
	}
	
	/**
	 * Get the writing part of the file, if opened for writing. 
	 *
	 * @return The writing part of the file.
	 */
	public DataOutputStream getWriter(){
		return writer;
	}

}
