package pinball.log;

import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.applet.*;

/** 
 * This reads the log file and generates an html file with the statistics. 
 */
public class MoviePlayer extends Applet{	
	/** File that data the data. */	
	private BufferedReader input;
	
	/** Name of log file. */
	private String logfile;
		
	/** Parameter for log file. */
	private String LOGNAME="logfile";

	/** Parameter for single log file. */
	private String SINGLE="single";

	/** Do only once. */
	private boolean once=true;
	
	/** Only play one clip. */
	private boolean single=false;
	
	/** The buttons panel. */
	private Panel buttons;
	
	/** Step button. */
	private Button step;
	
	/** Paused Button. */
	private Button pause;	
	
	/** Step Back Button. */
	private Button stepBack;	

	/** Rewind Button. */
	private Button rewind;	

	/** Back Button. */
	private Button backward;

	/** The viewer of the images. */
	private Viewer viewer;
	
	/** Is the system paused? */
	private boolean paused=true;
	
	/** Fast mode? */
	private Checkbox fast;
	
	/** Ball's location. */
	int xsize=0, ysize=0;

	/** Play's the movie. */
	MovieViewer mviewer;
	
	/** Initalize the applet. */
	public void init() {
		logfile = getParameter(LOGNAME);
	
		String param = getParameter(SINGLE);
		if(param!=null)
			single=new Boolean(param).booleanValue();

		param = getParameter("xsize");
		if(param!=null)
			xsize=new Integer(param).intValue();

		param = getParameter("ysize");
		if(param!=null)
			ysize=new Integer(param).intValue();
	}
	

	/** 
	 * Starts up the movie player.
	 */
	public void start() {
		if(once) {
			once=false;
			System.err.println("Pinball Project Movie Player Starting Up...");

			/* Watch the movie. */
			mviewer=new MovieViewer(logfile,this,single,xsize,ysize);
			viewer=mviewer.viewer();
			buttons=new Panel();
			buttons.setLayout(new FlowLayout(FlowLayout.CENTER));
			buttons.add(rewind=new Button("Rewind"));
			buttons.add(backward=new Button("Backward"));
			buttons.add(pause=new Button("Forward"));
			buttons.add(stepBack=new Button("Step <-"));
			buttons.add(step=new Button("Step ->"));
			buttons.add(fast=new Checkbox("Fast"));			
			add("North",buttons);
			viewer.fast(fast.getState());
			mviewer.start();
		}

	}
	
	/** The applet is done. */
	public void stop() {
		System.err.println("Movie Player destoryed");
		mviewer.stop();
	}
	
	/** Check for button presses. */
	public boolean action(Event e, Object arg) {
	
		Object target = e.target;
		
		if(target==pause) {
			//System.err.println("PAUSED");
			if(paused) {
				paused=false;
				pause.setLabel("Pause");

			}
			else if(!paused) {
				paused=true;
				pause.setLabel("Forward");
			} 
			viewer.paused(paused);
			viewer.play(true);
			viewer.rewind(false);
			return true;
		}
				
		if(target==step){
			paused=true;
			pause.setLabel("Forward");
			viewer.paused(paused);
			viewer.step();
			return true;
		}

		if(target==stepBack){
			pause.setLabel("Forward");
			viewer.stepBack();
			return true;
		}
		
		if(target==backward){
			pause.setLabel("Pause");
			viewer.paused(paused=false);
			viewer.rewind(true);			
			viewer.play(false);
			viewer.paused(false);
			return true;
		}

		if(target==rewind){
			pause.setLabel("Forward");
			viewer.paused(paused=false);
			viewer.begining();
			viewer.paused(paused=true);
			viewer.play(false);
			return true;
		}


		if(target==fast){
			viewer.fast(fast.getState());
			return true;
		}


		return false;
	}	
}
