package pinball.menuevent;

import pinball.*;
import pinball.buffer.*;
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;

import java.awt.event.*;

/**
 * The event to take place for when the pinball game exits.
 */
public class PinballExit implements ActionListener {
	/** The camera in the system. */
	protected Camera Qcam;
	
	/** Setup what to do with the game exits. */	
	public PinballExit(Camera Qcam) {
		this.Qcam=Qcam;
		GameOptions.setExit(this);
	}
	
	/**
	 * Exit the system.
	 */
    	public void actionPerformed(ActionEvent e) {
		exitSystem();
    	}

	/** 
	 * Exit the system and close up the log file. 
	 */	
	public void exitSystem() {
		System.err.println("System Was Exited.");		
		PinballLog.closeUp();		
		if(GameOptions.getDataIO()!=null)
			GameOptions.getDataIO().turnOff();
        	System.exit(0); 
	}

}
