#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <jni.h>

#include "pinball_player_nativeimageprocess_NativeImageProcessProcessImage.h"

JNIEXPORT void JNICALL 
Java_pinball_player_nativeimageprocess_NativeImageProcessProcessImage_findDifference
  (JNIEnv *env, jobject this, jint threshold, jboolean verbose, jint black, jint white, jint maxX, jint maxY, jint pixelRate, 
  jbyteArray jframe, jbyteArray jlastFrame, jbyteArray jlastDifferenceFrame, jbyteArray jcurrentDifferenceFrame, 
  jbyteArray jblipLocationFrame, jbyteArray jverboseFrame, jintArray jchanges){

	int xlocation, ylocation, diff=0, i=0, dot=0;
	jbyte *frame, *lastFrame, *lastDifferenceFrame, *currentDifferenceFrame, *blipLocationFrame, *verboseFrame;
	jint *changes;

	frame=(*env)->GetByteArrayElements(env,jframe,NULL);
	lastFrame=(*env)->GetByteArrayElements(env,jlastFrame,NULL);
	lastDifferenceFrame=(*env)->GetByteArrayElements(env,jlastDifferenceFrame,NULL);
	currentDifferenceFrame=(*env)->GetByteArrayElements(env,jcurrentDifferenceFrame,NULL);	
	blipLocationFrame=(*env)->GetByteArrayElements(env,jblipLocationFrame,NULL);
	verboseFrame=(*env)->GetByteArrayElements(env,jverboseFrame,NULL);
	changes=(*env)->GetIntArrayElements(env,jchanges,NULL);


	for (ylocation=0; ylocation<= maxY; ylocation+=pixelRate) {			
		for (xlocation=0; xlocation<= maxX; xlocation+=pixelRate) {
			
			/* Get the difference between the pixels. */
			diff=frame[i]-lastFrame[i];		
						
			/* Get the abs of the difference. */
			if(diff<0)
				diff=-diff;
			if (diff >= threshold) {
				currentDifferenceFrame[i] = black;
			}
			else
				currentDifferenceFrame[i] = white;
		}
	}

	if(				
			/* Exclusive OR the current difference frame and the blip location frame.
			   If there is a change note it. 
			   This is the new way the finds multiple objects.
			*/
			if (currentDifferenceFrame[i] != blipLocationFrame[i]) {				
				changes[dot]=i;
				dot++;
			}
			i++;

	
	/* Indicate no more changes. */
	changes[dot]=-1;
}

void andChanges(jbyte *frame1, jbyte *frame2, jbyte *blips, jint black, jint white, jint size) {
	int f=0;

	while(frame1[f]!=-1) {
		/* Create the blip location by logically ANDing the last
		   and current difference images. */
		if (frame1[f] == black &&
		frame2[f] == black) 
			blips[f] = black;								

		/* Nothing changed. */
		else 
			blips[f] = white;
	}
}

void temp() {
for (ylocation=0; ylocation<= maxY; ylocation+=pixelRate) {			
		for (xlocation=0; xlocation<= maxX; xlocation+=pixelRate) {
			
			/* Get the difference between the pixels. */
			diff=frame[i]-lastFrame[i];		
						
			/* Get the abs of the difference. */
			if(diff<0)
				diff=-diff;
			if (diff >= threshold) {
				currentDifferenceFrame[i] = black;
			}
			else
				currentDifferenceFrame[i] = white;
								
			/* Create the blip location by logically ANDing the last
			   and current difference images. */
			if (lastDifferenceFrame[i] == black &&
			currentDifferenceFrame[i] == black) {				
				blipLocationFrame[i] = black;								
			} 
			
			/* Nothing changed. */
			else {
				if(verbose)
					verboseFrame[i]=white;
				blipLocationFrame[i] = white;
			}
			
						
			/* Exclusive OR the current difference frame and the blip location frame.
			   If there is a change note it. 
			   This is the new way the finds multiple objects.
			*/
			if (currentDifferenceFrame[i] != blipLocationFrame[i]) {				
				changes[dot]=i;
				dot++;
			}
			i++;
		}
	}
}
