#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <jni.h>

#include "pinball_player_nativeimageprocesschanges_NativeImageProcessChangesProcessImage.h"

int find(int pixel, jint *in, int inSize) {
	int dot=0, found=0;
	
 	for(dot=0;dot<inSize;dot++) {
		if(pixel>in[dot])
			break;
		if(pixel==in[dot]) {
			found=1;
			break;
		}
	}
	
	return found;			
}

void andDifferences(jint *one, jint *two, int size, jint *blip, int blipSize, jint *changes, JNIEnv *env) {
	int i=0,dot=0;
	

	for(i=0;one[i]!=-1;i++) {
		/* Create the blip location by logically ANDing the last
		   and current difference images. */
		if (find(one[i],two,size)) {				
			blip[dot] = one[i];
			dot++;
		} 
	}
	
	blip[dot]=-1;
	blip[blipSize-1]=dot;
}
			
void xorDifferences(jboolean verbose, jint *one, jint *two, int size, jint *changes, jbyte *verboseFrame, jbyte black, JNIEnv *env) {
 
	/* Exclusive OR the current difference frame and the blip location frame.
	   If there is a change note it. 
	   This is the new way the finds multiple objects.
	*/
		
	int i=0,dot=0;

	for(i=0;one[i]!=-1;i++) {		
		if (!find(one[i],two,size-1)) {				
			changes[dot]=one[i];
			dot++;
			/* Make frame to be the blips image. */
			if(verbose)
				verboseFrame[one[i]]=black;				
		}
	}
	/* Indicate no more changes. */
	changes[dot]=-1;
}

JNIEXPORT void JNICALL 
Java_pinball_player_nativeimageprocesschanges_NativeImageProcessChangesProcessImage_findDifferenceChanges
  (JNIEnv *env, jobject this, jint threshold, jboolean verbose, 
  jint black, jint white, jint maxX, 
  jint maxY, jint pixelRate, 
  jbyteArray jframe, jbyteArray jlastFrame, jbyteArray jlastDifferenceFrame, 
  jbyteArray jcurrentDifferenceFrame, 
  jintArray jblips, jbyteArray jverboseFrame, jintArray jchanges, jintArray jlastChanges, 
  jintArray jcurrentChanges){

	int xlocation, ylocation, diff=0, i=0, dot=0;
	jbyte *frame, *lastFrame, *lastDifferenceFrame, *currentDifferenceFrame, *verboseFrame;
	jint *changes, *lastChanges, *currentChanges, *blips;

	frame=(*env)->GetByteArrayElements(env,jframe,NULL);
	lastFrame=(*env)->GetByteArrayElements(env,jlastFrame,NULL);
	lastDifferenceFrame=(*env)->GetByteArrayElements(env,jlastDifferenceFrame,NULL);
	currentDifferenceFrame=(*env)->GetByteArrayElements(env,jcurrentDifferenceFrame,NULL);	
	blips=(*env)->GetIntArrayElements(env,jblips,NULL);
	verboseFrame=(*env)->GetByteArrayElements(env,jverboseFrame,NULL);
	changes=(*env)->GetIntArrayElements(env,jchanges,NULL);
	lastChanges=(*env)->GetIntArrayElements(env,jlastChanges,NULL);
	currentChanges=(*env)->GetIntArrayElements(env,jcurrentChanges,NULL);	

	for (ylocation=0; ylocation<= maxY; ylocation+=pixelRate) {			
		for (xlocation=0; xlocation<= maxX; xlocation+=pixelRate) {
			if(verbose)
				verboseFrame[i]=white;						

			/* Get the difference between the pixels. */
			diff=frame[i]-lastFrame[i];		
						
			/* Get the abs of the difference. */
			if(diff<0)
				diff=-diff;
			if (diff >= threshold) {				
				currentChanges[dot]=i;
				dot++;
			}
			
			i++;
		}
	}

	currentChanges[dot]=-1;
	currentChanges[(*env)->GetArrayLength(env,jcurrentChanges)-1]=dot;
	
	if(currentChanges[(*env)->GetArrayLength(env,jcurrentChanges)-1]<=lastChanges[(*env)->GetArrayLength(env,jlastChanges)-1])
		andDifferences(currentChanges,lastChanges,lastChanges[(*env)->GetArrayLength(env,jlastChanges)],blips,(*env)->GetArrayLength(env,jblips),changes,env);
	else	andDifferences(lastChanges,currentChanges,dot,blips,(*env)->GetArrayLength(env,jblips),changes,env);	
	
	if(currentChanges[(*env)->GetArrayLength(env,jcurrentChanges)-1]>=blips[(*env)->GetArrayLength(env,jblips)-1])	
		xorDifferences(verbose,currentChanges,blips,(*env)->GetArrayLength(env,jblips),changes,verboseFrame,black,env);
	else	xorDifferences(verbose,blips,currentChanges,(*env)->GetArrayLength(env,jcurrentChanges),changes,verboseFrame,black,env);

}
