#include <stdio.h>
#include <fcntl.h>
#include <termios.h>
#include <sys/ioctl.h>

int serialFd;
int LR_READINGLEN = 12;

void main() {
	int i,success;

   /* Holds all the parameters/settings of serial port. */
   struct termios newterm; 

	char *SerialPortName="/dev/ttyd0";


	char buff1[2],buff2[2],buff3[2],buff4[2];

	char buff[4];
	
	buff1[0]=0;
	buff2[0]=0;
	buff3[0]=0;
	buff4[0]=0;
	
	buff[0]=0;
	buff[1]=0;
	buff[2]=0;
	buff[3]=0;
		
	//fprintf(stderr,"O\n");
	
	 if ((serialFd = open(SerialPortName, O_RDWR | O_NONBLOCK | O_NOCTTY)) < 0 ){  
      fprintf(stderr, "Could not open serial port.");
      exit(1);
   }

	if (tcgetattr(serialFd, &newterm) < 0) {
		fprintf(stderr,"Error getting attributes");
		exit(1);
	}
	
	 /*Set I/O flags*/ /*Note IXOFF was tried and caused more errors*/
//   newterm.c_iflag = IGNBRK;   
	newterm.c_iflag = 0;

   /*Set local flags*/
   newterm.c_lflag = 0;
   newterm.c_oflag = 0 ;

  /*Set Control flags:  Allow 8 data bits, no parity and one stop bit.
*/
   newterm.c_cflag = (CS8 | CREAD | CLOCAL );

   
   /* Will wait until the specified amount of bytes are read from the
      serial port.  If set to 0, once the specified time (see below) has
      expired, the read call can return with no read data. */
   newterm.c_cc[VMIN] = 0;   
   newterm.c_cc[VTIME] = 0;   
   
   /* Set port speed. */
   cfsetospeed(&newterm, B9600);
   cfsetispeed(&newterm, B9600);
   
   /* make raw */
   cfmakeraw(&newterm);

   /* Get rid of any data on the port by flushing. */ 
   if (tcflush(serialFd, TCIOFLUSH) == -1)
      fprintf(stderr, "Falied Flush\n");

   /* Set the serial port to the above settings. */ 
   if (tcsetattr(serialFd, TCSANOW, &newterm) == -1)
      fprintf(stderr, "Failed setattr\n");



	fprintf(stderr,"Wrote\n");

	write(serialFd,"!0SDFF",6);
	usleep(500000);
	write(serialFd,"!0SSAB",6);
	usleep(500000);
	//write(serialFd,"!0RC",4);	
	
	while(1){
	static int toggle;
	if(toggle){
	  write(serialFd,"!0SOFF",6);
	  toggle = 0;
	} else {
	  write(serialFd,"!0SO00",6);
	  toggle = 1;
	}
  	fprintf(stderr, "Read\n");

	write(serialFd,"!0RD",4);
	//usleep(1000);
	
	fprintf(stderr,"CLOCK: %d\r",clock());	
	while(getReading(buff)!=1) {
		//write(serialFd,"!0RC",4);
		fprintf(stderr,"CLOCK: %d\r",clock());	
		//fprintf(stderr,".");
		//usleep(1000);
	}
	}
	fprintf(stderr,"GOT SOMETHING: ");
	
	
	//fprintf(stderr,"A %c%c%c%c\n",buff1[0],buff2[0],buff3[0],buff4[0]);
	
	fprintf(stderr,"Data %c%c%c%c\n",buff[0],buff[1],buff[2],buff[3]);
	
	exit(0);
}


int fdHasCharacters (int fileDes)
{
  long int bytesToRead = 0 ;
  if(ioctl (fileDes, FIONREAD, (caddr_t) &bytesToRead) == -1) {
     printf("fdHasCharacters(): ioctl (...FIONREAD...) failed -- ") ; 
     return (-1) ;  
  }
  return bytesToRead ; /* Number of bytes available at serial port. */
}


int getReading(unsigned char *buffer){

   unsigned char *ptr;
   int numOfBytes, numReadBytes, 
       success = 0;

   /* Read any bytes available at the serial port.  Can only obtain one 
      reading at a time. */
   if((numOfBytes = fdHasCharacters(serialFd)) == 2){
      numReadBytes = (numOfBytes >= LR_READINGLEN) ? LR_READINGLEN - 1 : 
                      numOfBytes;                                

      if(read(serialFd, ptr = buffer, numReadBytes ) == numReadBytes){
//      	fprintf(stderr,"NUM: %d\n",numReadBytes);
	buffer[numReadBytes] = '\0';
	fprintf(stderr,"\nDATA: %d/%s\n", numReadBytes,buffer);
         success = 1;
         //*ptr = '\0'; 
      }      
   }      
   return success;
}   
   

