/*
	*******************
	* Alpha Version 1 *
	*******************
	
	Dayton Clark
	E-mail: dayton@sci.brooklyn.cuny.edu 
	
	Lawrence Goetz
	E-mail: goetz@dorsai.org
	Homepage: http://pages.prodigy.com/goetz

	Thanks to Y. Mok (pencil@escape.com) for originally 
	working on the project.	
*/


#include <StubPreamble.h>
#include <stdio.h>
#include "pinball_part_Camera.h"

/* Camera driver. */
#include "qcread.h"


/* Zoomed size for image. */
int zoomed;

/* Used for getopt so compiler is satisfied. */
extern char *optarg;
extern int optind;
extern int optopt;
extern int opterr;
extern int optreset; 
int getopt(int argc, char * const *argv, const char *optstring);


void pinball_part_Camera_Init(struct Hpinball_part_Camera *this) {
	/* Over ride values. */
	int x=0,y=0,xo=0,yo=0,t=0;
	
	printf("Initalizing the Quick Cam.\n");

	x=unhand(this)->xsize;
	y=unhand(this)->ysize;

	xo=unhand(this)->xoffset;
	yo=unhand(this)->yoffset;
	
	t=unhand(this)->transfer;

	if(x==-1)
		x=0;

	if(y==-1)
		y=0;

	if(xo==-1)
		xo=0;

	if(yo==-1)
		yo=0;
		
	if(t==-1)
		t=0;

	/* Initalize the qcread driver. */
	qcread_init(x,y,xo,yo,t);
	
	/* Display the camera information. */
	print_camera_info();			

	fflush(stderr);

	unhand(this)->xsize=qcread_x();	
	unhand(this)->ysize=qcread_y();

	unhand(this)->xoffset=qcread_xoffset();	
	unhand(this)->yoffset=qcread_yoffset();

	unhand(this)->zoom=qcread_zoom();

	unhand(this)->buffers=qcread_buffer_size();
	unhand(this)->displayRate=qcread_display_rate();
	unhand(this)->transfer=qcread_imagetype();
	
	unhand(this)->brightness=qcread_brightness();
	unhand(this)->contrast=qcread_contrast();
	
}

/* GrabFrame from the Camera object: Grab images from the QuickCam. */


void pinball_part_Camera_GrabFrame(struct Hpinball_part_Camera *this, HArrayOfByte *buffer) 

{	
	unsigned char *data = unhand(buffer)->body;
		
//	printf("Address of buffer: %x\n",data);
	qcread_image(data);	
}
void pinball_part_Camera_FrameResize(struct Hpinball_part_Camera *this,long width,long height, long xoffset, long yoffset, long transfer) {
	kill_camera();
	printf("Someone sent %d", yoffset);
	qcread_init(width,height,xoffset,yoffset,transfer);
	unhand(this)->xsize=qcread_x();	
	unhand(this)->ysize=qcread_y();
	
}
