package pinball.part;         

import pinball.*;                  
import pinball.io.*;              


import java.io.*;
import java.util.*;

/** Stores the time elapsed since the flipper flipped. */
public class FlipperTimeStamp implements Serializable{ 
        /** Used to keep the same serialized version. */ 
        static final long serialVersionUID = -2241137132827488901L;

        /** Time flipper flipped. */
        private long startTime;
        
        /**
         * Make a new flipper time stamp.
         */
        public FlipperTimeStamp () {
                startTime=System.currentTimeMillis();
        }
        
        /**
         * Flip start time. 
         */
        public void flip () {
                startTime=System.currentTimeMillis();           
        }
        
        /**
         * Should the flipper be reset. Has it been up long enough. 
         *
         * @param done Has the flipper been up at least this long?
         */
        public boolean reset(long done) {
                long elapsed; /* Elapsed time flipper was up. */
                
                elapsed=System.currentTimeMillis()-startTime;
                        
                /* Was it up long enough? */
                if(elapsed>=done) {
                        /* Time since reset. Used in testing flippers. 
*/
                        startTime=System.currentTimeMillis();
                        return true;
                }
                else return false;
        }
}
