package pinball.part;

import java.awt.*;
import java.io.*;
import java.util.*;

import pinball.io.*;

/** Send more code signals by flashing a light. */
public class MorseCode {
	/** Time for a dot. */
	public static int dot=300;
	
	/** Time betwen a symbol. */
	public static int symbolSpace=dot;

	/** Time for a dash. */
	public static int dash=dot*4;
	
	/** Time between characters. */	
	public static int charSpace=dash;

	/** Time between words. */
	public static int wordSpace=dot*8;

	/** What to use to send the signal. */
	private Flasher signal;

	/** Send the signals. */
	public MorseCode() {
		signal=new Flasher();
	}

	/** Send a signal. 
	 *
	 * The command line has the string to send. If nothing is given,
	 * the system sends the test message SOS.
	 *
	 */		
	public static void main(String args[]) {
		if(args.length>0)
			new MorseCode().test(args[0]);
		/* Give a default string. */
		else	new MorseCode().test("SOS");
	}
	
	/** Send a message. 
	 * @param string the message to send.
	 */
	public void test(String string) {
		message(string);
		signal.releaseLock();
		System.exit(0);
	}	
	
	/** Send a dot. */
	public void dot(){
		try{
		signal.on();
		Thread.sleep(dot);
		signal.off();
		}
		catch (Exception e){System.err.println(e);}
	}

	/** Send a dash. */
	public void dash(){
		try{
		signal.on();
		Thread.sleep(dash);
		signal.off();
		}
		catch (Exception e){System.err.println(e);}
	}

	/** Send an encoded character. 
	 * @param item the character to send.
	 */
	public void transmit(String item) {
		for(int i=0;i<item.length();i++) {
			char symbol=item.charAt(i);
			if(symbol=='.')
				dot();
			if(symbol=='-')
				dash();
			try{Thread.sleep(symbolSpace);}
			catch(Exception e){}
		}
	}
	
	/** Encode a character.
	 * @param character character to encode.
	 */
	public void encodeChar(char character){
		if(character=='A')
			transmit(".-");
		if(character=='B')
			transmit("-...");
		if(character=='C')
			transmit("-.-.");		
		if(character=='D') 
			transmit("-..");
		if(character=='E')
			transmit(".");
		if(character=='F')
			transmit("..-.");
		if(character=='G')
			transmit("--.");
		if(character=='H')
			transmit("....");
		if(character=='I')
			transmit("..");
		if(character=='J')
			transmit(".---");
		if(character=='K')
			transmit("-.-");
		if(character=='L')
			transmit(".-..");
		if(character=='M')
			transmit("--");
		if(character=='N')
			transmit("-.");
		if(character=='O')
			transmit("---");
		if(character=='P')
			transmit(".--.");
		if(character=='Q')
			transmit("--.-");		
		if(character=='R')
			transmit(".-.");
		if(character=='S')
			transmit("...");
		if(character=='T')
			transmit("-");
		if(character=='U')
			transmit("..-");
		if(character=='V')
			transmit("...-");
		if(character=='W')
			transmit(".--");
		if(character=='X')
			transmit("-..-");
		if(character=='Y')
			transmit("-.--");
		if(character=='Z')
			transmit("--..");
		if(character=='0')
			transmit("-----");
		if(character=='1')
			transmit(".----");
		if(character=='2')
			transmit("..---");
		if(character=='3')
			transmit("...--");
		if(character=='4')
			transmit("....-");
		if(character=='5')
			transmit(".....");
		if(character=='6')
			transmit("-....");
		if(character=='7')
			transmit("--...");
		if(character=='8')
			transmit("---..");
		if(character=='9')
			transmit("----.");	
	}
	
	/** Send characters. 
	 * @param message the characters to send.
	 */ 
	public void sendCharacters(String message) {
		for(int i=0;i<message.length();i++) {
			char character=message.charAt(i);
			encodeChar(character);
			try{Thread.sleep(charSpace);}
			catch(Exception e){}
		}
	}
	
	/** Send a message. 
	 * @param message the message to send.
	 */
	public void message(String message){
		StringTokenizer st = new StringTokenizer(message);
           	while (st.hasMoreTokens()) {
               		sendCharacters(st.nextToken().toUpperCase());
			try{Thread.sleep(wordSpace);}
			catch(Exception e){}

           	}
	}
}
