package pinball.part;

import pinball.io.*;
import java.lang.*;

/** A robot that moves about. */
public class MovitRobot {
	/** The controller. */
	private DataIO control;
	
	/** Which board the robot uses on the controller. */
	private int board=1;
	
	/** Left forward. */	
	private static double LF=1;

	/** Left backward. */
	private static double LB=0;

	/** Right forward. */
	private static double RF=2;

	/** Right backward. */
	private static double RB=3;
	
	/** Commands for the system. */
	public static double 
			FORWARD=Math.pow(2,LF)+Math.pow(2,RF), 
			BACKWARD=Math.pow(2,LB)+Math.pow(2,RB), 
			LEFT=Math.pow(2,LB)+Math.pow(2,RF), 
			RIGHT=Math.pow(2,LF)+Math.pow(2,RB), 
			STOPPED=0;
	
	/** Current system state. */
	private double state;
	
	/** Build the robot. */
	public MovitRobot() {
		control=new DataIO(board);
		state=STOPPED;
	}
	
	/** Move forward. */
	public void forward() {
		try{
		/*
		control.resetOutputLine(LB);
		Thread.sleep(10);
		control.resetOutputLine(RB);
		Thread.sleep(10);
		control.setOutputLine(LF);
		control.setOutputLine(RF); 
		*/
		control.setStates(0);
		Thread.sleep(10);
		control.setStates((int)FORWARD);
		}
		catch(Exception e){}
		state=FORWARD;
	}

	/** Move backward. */
	public void backward() {
		try{
		/*
		control.resetOutputLine(LF);
		Thread.sleep(10);
		control.resetOutputLine(RF);
		Thread.sleep(10);
		control.setOutputLine(LB);
		control.setOutputLine(RB);
		*/
		control.setStates(0);
		Thread.sleep(10);
		control.setStates((int)BACKWARD);
		}
		catch(Exception e){}
		state=BACKWARD;
	}
	
	/** Move clockwise. */
	public void clockwise() {
		try{
		/*
		control.resetOutputLine(LB);
		Thread.sleep(10);
		control.resetOutputLine(RF);
		Thread.sleep(10);
		control.setOutputLine(LF);
		control.setOutputLine(RB);
		*/
		control.setStates(0);
		Thread.sleep(10);
		control.setStates((int)RIGHT);
		
		}
		catch(Exception e){}
		state=RIGHT;
	}

	/** Move counterclockwise. */	
	public void counterClockwise() {
		try{
		/*
		control.resetOutputLine(LF);
		Thread.sleep(10);
		control.resetOutputLine(RB);
		Thread.sleep(10);
		control.setOutputLine(LB);
		control.setOutputLine(RF);
		*/
		control.setStates(0);
		Thread.sleep(10);
		control.setStates((int)LEFT);

		}
		catch(Exception e){}
		state=LEFT;
	}

	/** Stop the robot. */
	public void stop() {
		try{
		/*
			for(int i=0;i<4;i++)
				control.resetOutputLine(i);
		*/			
			control.setStates((int)STOPPED);
		}		
		catch(Exception e){}
		state=STOPPED;
	}

	/** Turn off the robot. */	
	public void off() {	
		control.turnOff();
		state=STOPPED;
	}

	/** Test the robot. */	
	public static void main(String args[]){
		MovitRobot robot=new MovitRobot();
		robot.stop();
		try{
			robot.forward();
			Thread.sleep(2000);
			robot.stop();
			robot.backward();
			Thread.sleep(2000);		
			robot.stop();
			robot.clockwise();
			Thread.sleep(2000);		
			robot.counterClockwise();
			Thread.sleep(2000);		
			robot.stop();

			robot.off();
		}
		catch(Exception e){System.err.println(e);} 			
		System.exit(0);		
	}

	/** What is the state of the robot.
	 @return the state of the robot. */	
	public int state() {
		return (int)state;
	}
	
	/** Get the controls. 
	@return the controls for the robot.
	*/
	public DataIO io() {
		return control;
	}
}
