package pinball.part;

import pinball.*;
import pinball.io.*;
import pinball.buffer.*; 
import pinball.server.*;
import pinball.player.*;

import java.io.*;
import java.util.*;

/** 
 * The plunger for the pinball machine.
 */
public class Plunger {
	/** Used to control the plunger. */
	private static transient DataIO plunger;
		
	/** Code to launch the ball. */
	private final int relay1=64;
	private final int relay2=128;
	
	/** Has the plunger been launched. */
	private boolean launched=false;

	/** Create the plunger. */
	public Plunger(DataIO plunger){
		/* If playing from a file, don't make the plunger. */
		if(GameOptions.play())
			return;
		this.plunger=plunger;
		//try{plunger.setStates(relay1);}
		//catch(Exception e){}
		System.err.println("Plunger Made.");
	}


	/** 
	 * Launch the ball. 
	 */
	public void launchBall() {
		launched=true;
		GameOptions.launchBall(false);
		try{	plunger.setStates(relay1);
			Thread.sleep(100);
			plunger.setStates(relay2);		}
		catch (Exception e){}
	} 			


	/**
	 * Check if the ball was launched.
	 *
	 * @return launched status.
	 */
	public boolean ballLaunched() {
		return launched;
	}
	
	

	/** 
	 * Reset the plunger. 
	 */	
	public void reset() {
		launched=false;
		try{plunger.setStates(relay1);}	
		catch (Exception e){}
	}
	 
	public static void main(String args[]) {
		Plunger p=new Plunger(new DataIO());
		
		try{
				p.launchBall();
				Thread.sleep(1000);
			System.exit(0);
		}
		catch (Exception e){}
	}

}

