package pinball.part;

import java.io.*;
import java.awt.*;

import pinball.buffer.*;
import pinball.*;
import pinball.log.*;

/** Allows the reading of data from the sound card. */
public class SoundCard {
	/** Size of the buffer. */
	private static int BUFFERSIZE=512;

	/** Data from the sound card. */
	private byte data[]=new byte[BUFFERSIZE];
	

	/* Load the library. */
	static {
		System.loadLibrary("SoundCard");
	}
	
	/** Initalize the sound card. */
	protected native void Init();
	
	/** Listen to the card. */
	protected native void listen(byte data[],int size);
	
	/** Create the sound card. */
	public SoundCard() {
		System.err.println("Attempting to startup the sound card.");
		Init();
		System.err.println("Initalized sound card.");
	}
	
	/** Test the sound card. */
	public static void main(String args[]) {
		System.err.println("Starting up the sound card.");
		SoundCard sound=new SoundCard();
		new SoundCardDisplay(sound);
		//while(true)
		//	sound.test3();
	}

	/** Test clap. */
	public void test() {
		byte voice[];
		voice=getSound();
		int clapCount=0;
		
		//System.err.println("SOUND: "+voice.length);
		for(int i=0;i<voice.length;i++) {
			int noise=Math.abs((byte)voice[i]);
			if(noise>=120 && noise<127)
				clapCount++;			
		}
		float percent=clapCount;
		percent/=voice.length;
		percent*=100;
		if(percent>50)
		System.err.println("Clap Percent= "+percent+" Clap Count= "+clapCount);
		//System.err.println();
	}	
	
	/** Test range. */
	public void test2() {
		byte voice[];
		voice=getSound();
		int high=0,low=0,mid=0;
		listen(data,BUFFERSIZE);
		for(int i=0;i<voice.length;i++) {
			int noise=(byte)voice[i];
			if(noise==127)
				high++;
			else if(noise==-128)
				low++;	
			else mid++;	
		}
		System.err.println("High= "+high+" Mid= "+mid+" Low="+low);
	}


	/** Test clap. */
	public void test3() {
		byte voice[];
		voice=getSound();
		int clapCount=0;
		
		int soundTotal=0;
		
		//System.err.println("SOUND: "+voice.length);
		for(int i=0;i<voice.length;i++) {
			int noise=Math.abs((byte)voice[i]);
			//if(noise>=120 && noise<127)
			//	clapCount++;
			soundTotal+=noise;
		}
		System.err.println("Sound Total "+soundTotal);
		
	}	


	/** 
	 * Get the sound from the card.
	 * @return The sound from the card.
	 */
	public byte[] getSound() {
		listen(data,BUFFERSIZE);
		return data;
	}
	
	
}
