package pinball.part;

import java.io.*;
import java.awt.*;

import pinball.buffer.*;
import pinball.*;
import pinball.log.*;

/** Displays the graph of sound. */
public class SoundCardDisplay extends Frame {
//	private MovitRobot robot=new MovitRobot();
	
	/** The sound card. */
	public SoundCard sound;
	
	/** The sound sample. */
	public byte sample[];
	
	/** The graph display. */
	public SoundCardGraph graph;
	
	private int totals[]=new int[12];
	private int nextTotal=0;
	
	private int state=0;
	private int lastState=state;
	
	/** Display the sound graph on the screen. 
	 * @param sound the sound card to get the sounds from.
	 */
	public SoundCardDisplay(SoundCard sound) {
		this.sound=sound;
		setSize(512,300);
		setVisible(true);
		add(graph=new SoundCardGraph(size().width,size().height));
		
		/** Keep getting sound samples. */
		while(true) {
			sample();
			test();
			graph.setSample(sample);
			try {Thread.sleep(50);}
			catch(Exception e){}
		}
	}	


	/** Test sound */
	public void test() {
		byte voice[];
		voice=sample;
		int clapCount=0;
		int noise=0;
		
		int soundTotal=0;
		//System.err.println("SOUND: "+voice.length);
		for(int i=0;i<voice.length;i++) {
			noise=voice[i];
			if(noise>=0){
				noise=(127-noise);
			}
			if(noise<0)
				noise=(128+noise);
//			System.err.print(noise+" , ");
			if(noise>50)
				soundTotal++;
		}
		System.err.println("Sound Total "+soundTotal);
		/*
		if(soundTotal>2)
			state++;
		if(state>5)
			state=0;
 		if(state==0 && lastState!=state)
			robot.stop();
		if(state==1 && lastState!=state)
			robot.forward();
		if(state==2 && lastState!=state)
			robot.stop();
		if(state==3 && lastState!=state)
			robot.clockwise();
		if(state==4 && lastState!=state)
			robot.stop();
		if(state==5 && lastState!=state)
			robot.counterClockwise();			
			
		lastState=state;
		System.err.println(state);
		*/
	}

	/** Get a sound sample. */		
	public void sample() {		
		sample=sound.getSound();
	}
}
