package pinball.part;

import pinball.*;
import pinball.io.*;
import pinball.buffer.*; 
import pinball.server.*;
import pinball.player.*;

import java.io.*;

/**
 * Used to start the a game of pinball. 
 */
public class StartButton {
	/** Used to control the button. */
	private static transient DataIO button;		
	
	/** Code to start the game. */
	private final int relay1=16;
	private final int relay2=32;
	
	private int relay=3;
	
	private boolean testing=true;

	/** Make a start button to start the pinball game. */
	public StartButton(DataIO button){
		/* If playing from a file, don't make the startButton. */
		if(GameOptions.play())
			return;

		/* Make startButton. */
		this.button=button;
		System.err.println("Start Button Made.");
	}		
	
	
	/** 
	 * Launch the ball. 
	 */
	public void press2() {
		if(GameOptions.running() && !GameOptions.play()) {
			try{	button.setStates(relay1);
				Thread.sleep(1000);
				button.setStates(relay2);		}
			catch (Exception e){System.err.println(e);}
		}
	} 			
	

	/** 
	 * Launch the ball. 
	 */
	public void press() {
		if((GameOptions.running() && !GameOptions.play()) || testing) {
			try{	
				button.setOutputLine(relay);
				Thread.sleep(100);
				button.resetOutputLine(relay);
				Thread.sleep(100);	
			}
			catch (Exception e){System.err.println(e);}
		}
	} 			


	public static void main(String args[]) {
		StartButton b=new StartButton(new DataIO());
		
		try{
			b.press();
			Thread.sleep(1000);
			System.exit(0);
		}
			catch (Exception e){System.err.println(e);}
	}
	

}
