package pinball.player.adjustable;

import pinball.*;
import pinball.buffer.*;
import pinball.io.*;
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;

import java.awt.*;
import java.io.*;
import java.util.*;

/** The information buffer's information */
public class AdjustableBufferInfo extends BufferInfo{
	
	/** Adjustments for the flippers. */
	protected static AdjustableFlippers adjustableFlippers;
		
			

	/** 
	 * Build the buffer information. 
	 * 
	 * @param id the id for the buffer.
	 */
	public AdjustableBufferInfo(int id) {	
		super(id);
	}

	/**
	 * Set the adjustable flippers. 
	 * 
	 * @param a The flippers.
	 */
	public void setAdjustableFlippers(AdjustableFlippers a) {
		adjustableFlippers=a;
	}
	
	/**
	 * Get the adjustable flippers.
	 *
	 * @return the adjustable flippers.
	 */  
	public AdjustableFlippers getAdjustableFlippers() {
		return adjustableFlippers;
	}

	/** 
	 * Save the buffer information to disk. 
	 *
	 * @param s location to write to.
	 */
	protected void writeObject(ObjectOutputStream s)
                                           throws IOException {
                 	System.err.flush();
                      s.defaultWriteObject();
                      // customized serialization code
                      
		      s.writeObject(adjustableFlippers);
                      s.writeInt(imageOffset);
                      
                      s.writeInt(top);
                      s.writeInt(bottom);
                      
                      s.flush();

                      
        }

	/** 
	 * Read the buffer information from the disk. 
	 *
	 * @param s location to read from.
	 */
	protected void readObject(ObjectInputStream s)
                                          throws IOException  {
                                          
                   	System.err.println("Reading");
                      try {s.defaultReadObject();

                      // customized deserialization code

			
		      adjustableFlippers=(AdjustableFlippers)s.readObject();
                      imageOffset=(int)s.readInt();
                      
                      top=(int)s.readInt();
                      bottom=(int)s.readInt();
                
                      /* Create the time stamp. */
                      timestamp=new TimeStamp();

                      }
  		      catch (ClassNotFoundException e){System.err.println(e);}
  		      	

        }

}

