package pinball.player.constantpartial;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.remote.*;

import java.awt.*;

/**
 * Player which constantly flips the flippers only when the ball is in the frame. 
 */
public class ConstantPartialRemoteStrategy extends ConstantPartialStrategy {
	/** Time to rest between flips. */
	private int reset= GameOptions.resetTime();
	
	/** Did flip take place. */
	private boolean flip=false;		
	
	
	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
	 */
	public ConstantPartialRemoteStrategy(Buffer buffer, TextArea gameStats) {
		this.buffer=buffer;
		id="ConstantPartial";

		this.stub=new RemoteStub(buffer,gameStats,this);
		stub.setPriority(Thread.NORM_PRIORITY);
		
		/* Make a larger boarder around the flippers.
		   This helps the system locate the ball out of play.
		*/
		boarder=4;
		stub.boarder(boarder);		
		new RemoteExit((RemoteStub)stub);

	}
		
		
}
