package pinball.player.handmouse;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.draw.*;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;


/**
 * This is where the picture is displayed to.
  */
public class HandMousePost extends Post {
	/** 
	 * Initalize the DrawingBoard. 
	 *
	 * @param buffer the first in the series of infomation buffers.
	 */
	public HandMousePost(Buffer buffer){	
		super(buffer);
		//System.err.println("\nThe HandMouse player does not do any drawing\nand so the Post thread must be left off.\nPlease restart, the Post thread will be disabled.\n");
		//System.exit(1);
	}
	
	/**
	 * Create the canvas drawn to.
	 *
	 * @param x Width of canvas.
	 *
	 * @param y Height of canvas.
	 *
	 * @return the canvas to drawn on.
	 */
	public DrawingCanvas canvas(int x,int y) {
		this.canvas=new HandMouseDrawingCanvas(x,y);
			      	
		return this.canvas;
	}
	
	
	
}
