package pinball.player.handmouse;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;

/**
 * The zone to be used for the mouse.
 */
public class Zone {
	/** The zone for the mouse. */
	private static Rectangle zone=new Rectangle(0,0,0,0);
	
	/** File for the zone. */
	private static String zoneFile="/tmp/zonefile.dat";
	
	/** Set the zone for the mouse. */
	public static void set(Rectangle mouseZone) {
		zone=mouseZone;
		write();
	}
	
	/** Get the zone for the mouse. */
	public static Rectangle get() {
		return zone;
	}
	
	/** Read in the previous zone. */
	public static void read() {	
		DataInputStream data=null;
		
 		try {
			data=new DataInputStream(new FileInputStream(zoneFile));			
			set(new Rectangle(data.readInt(),data.readInt(),data.readInt(),data.readInt()));
			System.err.println(zone.x+" "+zone.y+" "+zone.width+" "+zone.height);
			data.close();
			
		}
		catch (Exception e){
			System.err.println("Hand Mouse Zone file not found or first time running Hand Mouse Player.");
		}	
					

	}
	
	public static void write() {
		DataOutputStream data=null;
		
		try {
			data=new DataOutputStream(new FileOutputStream(zoneFile));
			data.writeInt(zone.x);
			data.writeInt(zone.y);
			data.writeInt(zone.width);
			data.writeInt(zone.height);
			data.close();
		}
		catch (Exception e){
			System.err.println("Error writing Hand Mouse Zone file.");
			System.exit(1);
		}
	}
}
