package pinball.player.hold;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;

import java.awt.*;


/** The player which holds the flippers up to catch the ball. */
public class HoldStrategy extends Strategy {
	/** Should it flip. */
	private boolean flip=false;

	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
  	 * @param camera the camera for the system.
	 */		
	public HoldStrategy(Buffer buffer, TextArea gameStats, Camera camera) {

		this.stub=new Stub(buffer,gameStats,this,camera);
		id="Hold";
	}
 				
				
	public HoldStrategy() {

	}
				
	/** 
	 * Should you flip or not. 
	 */
	public void decision() {		

		/* Set the default that it did not flip. */	
		flipperFlipped(false);
		
		/* Is there a ball to flip? If so flip it.*/
		/* Add the offset value for the ball's location so it's
		correctly found from original location in game. */
		
		x=buffinfo.blip().x();
		y=buffinfo.blip().y();
		
//		System.err.println("Ball: "+x+","+y+" Flipper height "+flipperHeight);
//		System.err.println("LeftX: "+leftX+" RightX: "+rightX);
			
		if(x!=-1)	
			x+=buffinfo.XOffset();
		if(y!=-1)	
			y+=buffinfo.YOffset();
			
		/* Flip the flippers. */
		//if(x>=0 && y>=flipperHeight) {
		if(x>=0) {
		
			/* Check for valid movement. Make sure it's not the flipper that
			is seens as movement.*/
			
				/* Flip the flipper to the corresponding half of the frame
				where the ball is found. */
			
				/* Find the distance of the ball from the flippers, 
				   to see which to flip. 
				*/
				if(x!=-1) {
					leftDistance=leftX-x;
					if(leftDistance<0)
						leftDistance=-leftDistance;

					rightDistance=rightX-x;
					if(rightDistance<0)
						rightDistance=-rightDistance;
					
				}
			
				/* Flip left flipper. */
				if(leftDistance<rightDistance) {
					stub.leftFlipperState(true);
				 }
				/* Flip right flipper. */
				if(rightDistance<leftDistance) {
					stub.rightFlipperState(true);
				 }
				/* Flip both. */
				if(x>(middle-5) && x<(middle+5)) {
					stub.leftFlipperState(true);
					stub.rightFlipperState(true);					
				}			 
		}

	}

}
