package pinball.player.human;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.remote.*;

import java.awt.*;


/**
 * Human player plays pinball over the network. 
 */
public class HumanRemoteStrategy extends HumanStrategy {

	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
	 */		
	public HumanRemoteStrategy(Buffer buffer, TextArea gameStats) {

		this.stub=new RemoteStub(buffer,gameStats,this);
		id="human";				
		
		window=new HumanWindow(100,100,stub);
		commands=window.getFlipperCommands();
		new RemoteExit((RemoteStub)stub);	
	} 
	
}			 
