package pinball.player.internet;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.network.*;
import pinball.player.remote.*;

import java.awt.*;

/**
 * Internet player sets up the server with a client already connected.
 */
public class InternetPlayer extends StdPlayer{
	/** Id of class. */
	static { id="inet"; }
	
	/** The server for the connection. */
	static MyServer server;
	
	/** 
	 * Start up the program. 
	 */
	public static void main(String args[]) {
		StdPlayer player=new InternetPlayer();
		player.makeIt(player,args);
	}
		
	/** 
	 * Get the strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
	 * @param camera the camera for the system.
 	 *
 	 * @return strategy thread.
	 */
	public Strategy serverStrategy(Buffer buffer,TextArea gameStats, Camera camera) {
		return new InternetPlayerStrategy(buffer,gameStats,camera,server);
	}

		
}
