package pinball.player.internet;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.network.*;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import java.net.*;


/**
 * The internet player's strategy.
 * This sends the location of the ball, and other data over to the client.
 * This starts up the server.
 */
public class InternetPlayerStrategy extends NetworkPlayerStrategy {
	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
	 * @param camera the camera for the system.
	 * @param server the server for the network.
 	 *
	 */		 	 
	public InternetPlayerStrategy(Buffer buffer,TextArea gameStats, Camera camera, MyServer server) {
		id="NetworkPlayer";
		this.stub=new Stub(buffer,gameStats,this,camera);
		this.server=server;
	}


	/** Startup the server. */
	public void custom() {	
		server=new MyServer(0,0,false);
		
		/* Write to the output stream so the other process can read the
		port number.*/
		System.out.println("PORT "+server.getPort());
		GameOptions.networkPort(server.getPort());
		
		server.connection();

		new NetworkListener(server,this.stub).start();
		bufferSize=GameOptions.bufferSize();
	}	

}
