package pinball.player.morsecode;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;


/**
 * Used for decoding flashes of light as morse code.
 */
public class MorseCodeStub extends Stub {
	

	/**
	 * The stub for the strategy.
	 *
	 * @param buffer The first buffer for the information buffers.
	 * @param gameStats the area on the screen to write stats info.
	 * @param strategy the strategy thread.
	 * @param camera the camera for the system.
	 */
	public MorseCodeStub(Buffer buffer, TextArea gameStats, Strategy strategy, Camera camera) {
		setupImage();
		this.camera=camera;
		stats=new Stats(this);
//		plunger=new Plunger(GameOptions.getDataIO());
		startButton=new StartButton(GameOptions.getDataIO());
		ballReturn=new BallReturn(GameOptions.getDataIO());
		GameOptions.setPlunger(plunger);
		this.buffer=buffer;
		this.gameStats=gameStats;
		this.strategy=strategy;
		buffinfo=buffer.info();

		
		left=new Flipper(GameOptions.getDataIO(),Flipper.LEFT);
		right=new Flipper(GameOptions.getDataIO(),Flipper.RIGHT);

		strategy.setQueue(queue);
		
		/** Don't do any timestamps. */
		timeStamp=false;

		/** Start imediately. */
		startDelay=false;
		
	}
		
	/** Needed for when this class is extended. */
	public MorseCodeStub(){}
	
	/**
	 * Search for the flipper the number of times given. 
	 *
	 * @param quantity number of times to look for the flippers. 
	 */
	public void findFlippers(int quantity) {
	}	

	public void statistics() {}
	
	public void setText(String text) {
		gameStats.setText(text);
	}

	public void appendText(String text) {
		gameStats.appendText(text);
	}
	
}
