package pinball.player.movitrobot;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;


/**
 * Control the robot.
 */
public class MovitRobotStub extends Stub {
	MovitRobot robot=new MovitRobot();
	
	/**
	 * The stub for the strategy.
	 *
	 * @param buffer The first buffer for the information buffers.
	 * @param gameStats the area on the screen to write stats info.
	 * @param strategy the strategy thread.
	 * @param camera the camera for the system.
	 */
	public MovitRobotStub(Buffer buffer, TextArea gameStats, Strategy strategy, Camera camera) { 
		super(buffer,gameStats,strategy,camera);
		GameOptions.setDataIO(robot.io());		
	}
	
	/** Move forward. */
	public void forward() {
		robot.forward();
	}
		
	/** Move backward. */
	public void backward() {
		robot.backward();
	}

	/** Move counterclockwise. */
	public void counterClockwise() {
		robot.counterClockwise();
	}

	/** Move clockwise. */
	public void clockwise() {
		robot.clockwise();
	}

	/** Halt the robot. */
	public void halt() {
		robot.stop();
	}

	/**
	 * Search for the flipper the number of times given. 
	 *
	 * @param quantity number of times to look for the flippers. 
	 */
	public void findFlippers(int quantity) {

	}
	
	/**
	 * Filter the image.
	 * 
	 * @param findFlippers Is the system finding the flippers.
	 */
	public void filter(boolean findFlippers) {
	}
		
	/** No statistics done. */
	public void statistics() {}

	/** Don't draw anything. */
	public void strategyDraw(Graphics g, int wSize, int hSize) {}
	
	/** Get the robot's status. 
	 * 
	 * @return status.
	 */
	public double robotStatus() {
		return robot.state();
	}
}
