package pinball.player.nativeimageprocess;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.network.*;
import pinball.player.remote.*;
import pinball.player.standard.*;
import pinball.part.*;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;

/**
 * Player which uses the native method to analyze the changes in the frames.
 */
public class NativeImageProcessPlayer extends StdPlayer {
	static{id="NatIP";}
	
	/** 
	 * Start up the program. Takes command line arguments.
   	 * Takes the following command line arguments:
	 * -s for server mode.
	 * -c for client mode.	 
	 */
	public static void main(String args[]) {
		StdPlayer player=new NativeImageProcessPlayer();
		player.makeIt(player,args);
	} 	
		
	/** 
	 * Get the analyze thread for the player. 
	 *
	 * @param buffer the first buffer in the series of buffers for the system.
	 * 
	 * @return Analyze thread.
	 */
	public Analyze analyze (Buffer buffer) {
		System.err.println("NATIVE STUFF");
		return new NativeImageProcessAnalyze(buffer); 
	}


}
