package pinball.player.nohit;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;

import java.awt.*;


/** The player never flips the flippers. */
public class NoHitStrategy extends Strategy {

	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
  	 * @param camera the camera for the system.
	 */		
	public NoHitStrategy(Buffer buffer, TextArea gameStats, Camera camera) {

		this.stub=new Stub(buffer,gameStats,this,camera);
		id="NoHit";
	}
 				
	/** For extended classes. */		
	public NoHitStrategy() {

	}
				
	/**
	 * Should you flip or not. It never flips.
	 */
	public void decision() {
											
	}

}
