package pinball.player.nopinball;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.network.*;
import pinball.player.remote.*;
import pinball.player.draw.*;

import java.awt.*;

/**
 * Player which does not use the pinball machine.
 */
public class NoPinballPlayer extends StdPlayer{
	/** Id of class. */
	static { id="nopinball"; }
	
	/** 
	 * Start up the program. Takes command line arguments.
   	 * Takes the following command line arguments:
	 * -s for server mode.
	 * -c for client mode.	 
	 */
	public static void main(String args[]) {		
		StdPlayer player=new NoPinballPlayer();
		player.makeIt(player,args);
	} 
	
		
	/** 
	 * Get the strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
  	 * @param camera the camera for the system.
 	 *
 	 * @return strategy thread.
	 */
	public Strategy localStrategy(Buffer buffer,TextArea gameStats, Camera camera) {
		return new NoPinballStrategy(buffer,gameStats,camera);
	}
	
}
