package pinball.player.nopinball;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.nohit.*;

import java.awt.*;
import java.util.*;


/** No pinball machine, so nothing to do. */
public class NoPinballStrategy extends NoHitStrategy {

	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
  	 * @param camera the camera for the system.
	 */		
	public NoPinballStrategy(Buffer buffer, TextArea gameStats, Camera camera) {
		GameOptions.pixelThreshold(8);
		this.stub=new NoPinballStub(buffer,gameStats,this,camera);
		id="nopinball";
	}

	/** Have a decision to move the mouse pointer. */ 				
	public void flippersCheck() {	
		decision();
	}
	
	/**
	 * Draw's nothing on the screen.
	 *
	 * @param g the graphics to draw to.
	 * @param cavasWidth the width of the canvas.
	 * @param canvcasHeight the hight of the canvas.
	 */
	public void draw(Graphics g, int canvasWidth, int canvasHeight) {
	}

}
