package pinball.player.pen;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.draw.*;
import pinball.player.standard.*;
import pinball.player.network.*;
import pinball.player.remote.*;

import java.awt.*;

/** The computer analyzes pen drawing and find the angle. */
public class PenPlayer extends StdPlayer{
	/** Id of class. */
	static { id="pen"; }
	
	/** 
	 * Start up the program. Takes command line arguments.
   	 * Takes the following command line arguments:
	 * -s for server mode.
	 * -c for client mode.	 
	 */
	public static void main(String args[]) {		
		StdPlayer player=new PenPlayer();
		player.makeIt(player,args);
	} 
	

	/** 
	 * Get the analyze thread for the player. 
	 *
	 * @param buffer the first buffer in the series of buffers for the system.
	 * 
	 * @return Analyze thread.
	 */
	public Analyze analyze (Buffer buffer) {
		return new PenAnalyze(buffer); 
	}

	/** 
	 * Get the strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
  	 * @param camera the camera for the system.
 	 *
 	 * @return strategy thread.
	 */
	public Strategy localStrategy(Buffer buffer,TextArea gameStats, Camera camera) {
		return new PenStrategy(buffer,gameStats,camera);
	}
	
	/** 
	 * Get the post thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
 	 *
 	 * @return strategy thread.
	 */
	public Post post(Buffer buffer){
		return new DrawPost(buffer);
	}
	
	
}
