package pinball.player.pen;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.draw.*;

import java.awt.*;
import java.util.*;


/** The computer analyzes pen drawing and find the angle. */
public class PenStrategy extends Strategy {

	private int lastX=0, lastY=0;
	
	private int angleThreshold=20;

	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
  	 * @param camera the camera for the system.
	 */		
	public PenStrategy(Buffer buffer, TextArea gameStats, Camera camera) {
		GameOptions.pixelThreshold(10);
		this.stub=new PenStub(buffer,gameStats,this,camera);
		id="Pen";
	}
 				
	
	public void option() {
		double angle;
		
		/* The objects found. */
		Vector blips=stub.getObjects();			
		
		/* The object. */
		Blip thing;
		
		if(blips.size()<=0) {		
			return;
		}
		
		System.err.print("\n");		
		for (int i=0; i < blips.size(); i++) { 
			thing=(Blip)blips.elementAt(i);
			
			int deltaX=thing.maxX()-thing.minX();
			int deltaY=thing.maxY()-thing.minY();
		
			lastX=x;
			lastY=y;
			angle=-1;
			
			if(deltaX==0) {
				System.err.println("Object "+(i+1)+" no slope");
				angle=90;				
			}
		
			if(deltaX!=0) {
				double slope=deltaY;
				slope /=deltaX;
		
				//System.err.println("Object "+(i+1)+"Slope: "+slope+" Changes:"+deltaX+" "+deltaY);
				double angleRadians=Math.atan(slope);
				angle=(angleRadians*180)/Math.PI;
				if(thing.end().y<thing.start().y)
					angle+=90;
//				System.err.println("Object "+(i+1)+" Angle: "+angle+" "+thing.start().y+" "+thing.end().y);
			}
			if(compareAngle(angle,0))
				angle=0;								
			if(compareAngle(angle,45))
				angle=45;					
			if(compareAngle(angle,90))
 				angle=90;
			if(compareAngle(angle,135))
				angle=135;
			System.err.println("Object "+(i+1)+" Angle: "+angle);			
		}
		
	}
				
	/** 
	 * Test to see if an angle is within a threshold.
	 * 
	 * @param angle angle to see if it is valid.
	 * @param compare angle to compare to. 
	 */
	private boolean compareAngle(double angle, double compare) {
		if(angle==-1)
			return false;
		if(compare !=0 && angle<=compare+angleThreshold && angle>=compare-angleThreshold)
			return true;
		if(compare==0 && (angle<=angleThreshold || angle>=180-angleThreshold))
			return true;
		return false;
	}
	/**
	 * Should you flip or not. It never flips.
	 */
	public void decision() {
												
	}
	
	/**
	 * Draw nothing.
	 *
	 * @param g the graphics to draw to.
	 * @param cavasWidth the width of the canvas.
	 * @param canvcasHeight the hight of the canvas.
	 */
	public void draw(Graphics g, int canvasWidth, int canvasHeight) {

	}

}
