package pinball.player.pen;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;


/**
 * Uses lines to control the system.
 */
public class PenStub extends Stub {
	/**
	 * The stub for the strategy.
	 *
	 * @param buffer The first buffer for the information buffers.
	 * @param gameStats the area on the screen to write stats info.
	 * @param strategy the strategy thread.
	 * @param camera the camera for the system.
	 */
	public PenStub(Buffer buffer, TextArea gameStats, Strategy strategy, Camera camera) { 
		super(buffer,gameStats,strategy,camera);
	}
		
	/**
	 * Search for the flipper the number of times given. 
	 *
	 * @param quantity number of times to look for the flippers. 
	 */
	public void findFlippers(int quantity) {
	}
	
	/**
	 * Reverse the image from the camera. 
	 *
	 * @param pixels the pixels from the camera.
	 * @param w the width of the image.
	 * @param h the hight of the image.
	 */
	public void reverseImage(byte [] pixels, int w, int h) {
		byte swap;
					
		int height=0;
		for(int i=0; i<h; i++) {
			for(int j=0; j<w/2; j++) {
				try{
					swap=pixels[height+j];
					pixels[height+j]=pixels[height+w-j];
					pixels[height+w-j]=swap;
				}
				catch(Exception e){}
			}
			height+=w;
		}
		
	}
		
	
	/**
	 * Filter out the persons right hand.
	 * 
	 * @param findFlippers Is the system finding the flippers.
	 */
	public void filter(boolean findFlippers) {						

	}
	
	public void statistics() {}

	public void strategyDraw(Graphics g, int wSize, int hSize) {}
}
