package pinball.player.random;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.remote.*;

import java.awt.*;

/** Player who randomly flips the flippers. */
public class RandomRemoteStrategy extends RandomStrategy {
	/** Time to rest between flips. */
	private int rest= GameOptions.resetTime();
	
	/** Did flip take place. */
	private boolean flip=false;
	

	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
	 */	
	public RandomRemoteStrategy(Buffer buffer, TextArea gameStats) {
		this.stub=new RemoteStub(buffer,gameStats,this);
		
		id="Random";
		boarder=4;
		new RemoteExit((RemoteStub)stub);
	}			
}
