package pinball.player.random;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.remote.*;

import java.awt.*;

/** Player who randomly flips the flippers. */
public class RandomStrategy extends Strategy {
	/** Time to rest between flips. */
	private int rest= GameOptions.resetTime();
	
	/** Did flip take place. */
	private boolean flip=false;
	

	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
  	 * @param camera the camera for the system.
	 */	
	public RandomStrategy(Buffer buffer, TextArea gameStats, Camera camera) {
		this.stub=new Stub(buffer,gameStats,this,camera);
		
		id="Random";
		boarder=16;
		stub.boarder(boarder);	
	}	
	
	/**
	 * Required for extended class.
	 */
	public RandomStrategy(){}
	
	/** 
 	 * Should you flip or not. 
 	 * 1/3 flip left, 1/3 right & 1/3 both.
	 */
	public void decision() {			
		/* Random choice. */
		double choice=Math.random();
			
		/* Reset flippers. */
		if(flip==false) {
				stub.leftFlipperState(false);
				stub.rightFlipperState(false);
				flip=true;
		}
	
		/* Flip flipper(s). */
		else if(flip==true && choice > 0.0) {				
 			if(choice>=.3)
				stub.leftFlipperState(true);
			if(choice<.6)
				stub.rightFlipperState(true);				
			flip=false;
		}
			
		/* Pause between flips. */	
		try {
       	       		Thread.sleep(rest);
      		} 
      		catch (InterruptedException e)
	       	{System.err.println(e);}
			
	}
}
