package pinball.player.random2;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;
import pinball.player.standard.*;
import pinball.player.remote.*;
import pinball.player.network.*;

import java.awt.*;

/**
 * Player which randomly flips the flippers.
 */
public class Random2Player extends StdPlayer{
	/** ID of class. */
	static { id="rand2"; }
	/** 
	 * Start up the program. Takes command line arguments.
   	 * Takes the following command line arguments:
	 * -s for server mode.
	 * -c for client mode.	 
	 */
	public static void main(String args[]) {		
		StdPlayer player=new Random2Player();
		player.makeIt(player,args);
	} 


	
	/** 
	 * Get the strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
 	 * @param camera the camera for the system.
 	 *
 	 * @return strategy thread.
	 */
	public Strategy localStrategy(Buffer buffer,TextArea gameStats,Camera camera) {
		return new Random2Strategy(buffer,gameStats,camera);
	}
	
	
	/** 
	 * Get the strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
 	 *
 	 * @return strategy thread.
	 */
	public Strategy clientStrategy(Buffer buffer,TextArea gameStats) {
		return new Random2RemoteStrategy(buffer,gameStats);
	}
}
