package pinball.server;

import java.net.*;
import java.io.*;

/** 
 * This is the network read & write controls. 
 * MyServer and MyClient extend this. 
 */

public class Network {
        /** Output for the server. */
	protected BufferedReader in;
	
        /** Input for the server. */
	protected PrintWriter 	out;
	
	/**
	 * Send out the output stream.
	 *
	 * @return output stream.
	 */
	public PrintWriter getOutStream() {
		return out;
	}

	/**
	 * Send out the input stream.
	 *
	 * @return input stream.
	 */
	public BufferedReader getInStream() {
		return in;
	}
	
	/**
	 * Send out data.
	 *
	 */
	public void transmit(String s) {
//		System.err.println("SENDING "+s);
		out.println(s);		
		out.flush();
//		System.err.println("SENT "+s);
	}
	

	/**
	 * Receive data.
	 *
	 * @return the data received.
	 */	
	public String receive() {
		String gotten=null;

//		System.err.println("Reading");

		try{
			gotten=in.readLine();
		}
		catch (Exception e) {
			System.err.println(e);
			gotten=null;
		}


//		System.err.println("Read");
	
		return gotten;
 	}
 }
