package pinball.server;

import pinball.*;

import java.net.*;
import java.io.*;

/** Used to send data over the network. */
public class NetworkDataSocket extends Network{
	/** Data socket. */
        private Socket socket;	
	
	/** 
	 * Have a client connect to the server and get the data socket.
	 * @sct the server that's waiting for a client.
	 * @timeout the timeout to wait for no response.
	 */
	public NetworkDataSocket(ServerSocket sct,int timeout){
		 /* Open the socket. */
		try {
			System.err.println("Waiting for connection.");
			socket = sct.accept();

			socket.setSoTimeout(timeout);

 			in = new BufferedReader (
			     new InputStreamReader(socket.getInputStream()));
		        out = new PrintWriter (
			     socket.getOutputStream(),false);			
		} catch (Exception e) {System.err.println(e);System.exit(1);}
	}
	
	/**
	 * Setup a data socket based on a pre existing socket.
	 */
	public NetworkDataSocket(Socket socket) {
		this.socket=socket;
		try {
			in = new BufferedReader (
			     new InputStreamReader(socket.getInputStream()));
		        out = new PrintWriter (
			     socket.getOutputStream(),false);
		}
		catch (Exception e) {System.err.println("NetworkDataSocket: "+e);System.exit(1);}
	}
	
	public void close() {
		try{
			socket.close();
		}
		catch (Exception e) {
			System.err.println(e);
			System.exit(1);
		}
	}
	
	public int port() {
		return socket.getLocalPort();
	}

	public boolean connected() {
		if(socket==null)
			return true;
		else return false;
	}
}
